// Batlship.java

// Plays Battleship Game: Find the Battleship in MaxMoves Moves



import java.io.*;

import java.util.*;



public class Batlship {



static int HEIGHT=5,

           WIDTH=10;

static char Emptypoint='X',

            Hitpoint=(char)178,

            Initpoint='.';



static int ReadInt() throws java.io.IOException

 {int Total=0,Sign=1;

  int Digit;

  // Eat Blanks

  while ((Digit=System.in.read())<=32);

  // Check for - sign

  if (Digit=='-')

   Sign=-1;

  else if (Digit>='0' && Digit<='9')

   Total=Digit-48;

  else return(-1);

  Digit=System.in.read();

  while (Digit>='0' && Digit<='9') {

   Total=(Total*10)+Digit-48;

   Digit=System.in.read();

  }

  return(Total*Sign);

}







static void InitBoard(char Board[][])

{int x,y;

 for(y=0; y<HEIGHT; y++)        // fill Board with periods

   for(x=0; x<WIDTH; x++)

     Board[y][x] = Initpoint;

}



static void PrintBoard(char Board[][])

{int x,y;

 System.out.print("   ");

 for (y=0;y<WIDTH;y++)

  System.out.print(y+" ");

 System.out.println();

 for(y=0; y<HEIGHT; y++) {      // print Board

  System.out.print(y+": ");

  for(x=0; x<WIDTH; x++)

   System.out.print(Board[y][x]+" ");

  System.out.println();

 }

}



static boolean pointsEqual(point X,point Y)

{return(X.x==Y.x && X.y==Y.y);}



static char pointStatus(point P,char Grid[][])

{return(Grid[P.y][P.x]);}



static boolean Hit(point P,point Boat[])

{int i;

 for (i=0;i<3 && !pointsEqual(P,Boat[i]);i++);

 return(i<3);

}



static void PrintSolnBoard(char Board[][],point Boat[])

{int x,y;

 point P=new point();

 for(y=0; y<HEIGHT; y++) {      // print Board

  for(x=0; x<WIDTH;  x++) {

   P.x=x; P.y=y;

   if (Hit(P,Boat)) System.out.print(Hitpoint);

   else System.out.print(Board[y][x]);

  }

  System.out.println();

 }

}



static void Getpoint(point P,char Board[][])

      throws java.io.IOException,OutOfRangeException,AlreadyCalledException

{boolean ok;

// do {  This version stops and displays our string... Loop is superfluous

  System.out.println("\nCoordinates: ");

  System.out.print("Enter Column and Row >");

  System.out.flush();

  P.x=ReadInt();

  P.y=ReadInt();

  ok=!(P.x < 0 || P.x >= WIDTH || P.y < 0 || P.y >=HEIGHT);

  if (!ok)

   if (P.x < 0 || P.x >= WIDTH)

    throw new OutOfRangeException(P.x+" is Out of Range");

   else

    throw new OutOfRangeException(P.y+" is Out of Range");

  else if (pointStatus(P,Board) !=Initpoint) {

   throw new AlreadyCalledException("Point ("+P.x+","+P.y+

                                           "was Previously Called");

  }

// } while (!ok);

}



// Place a ship in the grid, which is 0..4 0..8

static void PlaceShip(point Ship[])

{int Direction;

 Random Spots=new Random();

 Ship[0].y=(int)(Spots.nextDouble()*3);  // Ship starts in 1st 3 rows

 Ship[0].x=(int)(Spots.nextDouble()*6);  // Ship starts in 1st 6 columns

 Direction=(int)(Spots.nextDouble()*2);  // 0 ==> Vertical  1 ==> Horizontal

 if (Direction==1) {

  Ship[1].y=Ship[2].y=Ship[0].y;

  Ship[1].x=Ship[0].x+1;

  Ship[2].x=Ship[1].x+1;

 }

 else {

  Ship[1].x=Ship[2].x=Ship[0].x;

  Ship[1].y=Ship[0].y+1;

  Ship[2].y=Ship[1].y+1;

 }

}



static boolean GameWon(char Board[][],point Ship[])

{boolean Done=true;

 for (int i=0;i<3 && Done;i++)

  if (Board[Ship[i].y][Ship[i].x]!=Hitpoint) Done=false;

 return(Done);

}



public static void main(String[] args)

       throws java.io.IOException, AlreadyCalledException,OutOfRangeException

{char[][] Board=new char[HEIGHT][WIDTH];

 point P=new point();

 point Ship[]=new point[3];

 // Initialize the Ship's Point Objects

 for (int i=0;i<3;i++)

  Ship[i]=new point();

 if (args.length!=1) { // args.length is number of command line arguments

  //  Command Line form Incorrect

  System.out.println("Form: Batlship <MaxMoves>\n");

 }

 else {

  Integer Max=new Integer(args[0]);

  int MaxMoves=Max.intValue();

  int Moves=0;

  boolean Win;

  if (MaxMoves<1) {               // Exit if Max Moves < 1

   System.out.println("Max # Moves must be positive\n");

  }

  else {

   InitBoard(Board);

   PlaceShip(Ship);



   System.out.println("\nEnter coordinates in form x,y (<col>,<row>).\n");

   System.out.println("Use negative numbers to quit.\n");



   do {

    PrintBoard(Board);

    Getpoint(P,Board);

    if (Hit(P,Ship))   {

     Board[P.y][P.x]=Hitpoint;     // put box there

     System.out.println("\nHIT!\n");

    }

    else {

     Board[P.y][P.x]=Emptypoint;       // put box there

     System.out.println("\nMiss\n");

    }

   } while (!(Win=GameWon(Board,Ship)) && ++Moves < MaxMoves);

   // end do-while

   System.out.println("The solution (with your misses noted) is...\n");

   PrintSolnBoard(Board,Ship);

   System.out.println("The Ship's position is noted using "+Hitpoint);

   if (Win) System.out.println("You Win!\n");

   else System.out.println("You Lose!\n");

  } // else MaxMoves is positive

 } // else MaxMoves was on command line

} // end of main

} // End of Class

